<!-- -*- sgml -*- -->
<!DOCTYPE spec PUBLIC "-//Ken MacLeod//DTD GSF Spec//EN">
<spec>
  <head></head>
  
  <rules>
    <rule><query/TEI.2/     <isa/Holder/

      <!-- ignoring TEIHEADER for now -->

    <rule><query/TEXT/  <isa/Document/
      <rules>
	<rule><query/FRONT/ <isa/Holder/
	  <rules>
	    <rule><query/TITLEPAGE/ <isa/Holder/
	      <rules>
		<rule><query/DOCTITLE/ <isa/Holder/
		  <rules>
		    <rule><query/TITLEPART/ <save/{title}/
		  </rules> <!-- DOCTITLE -->
		</rule>
		<rule><query/DOCAUTHOR/ <isa/Author/
		  <push/{authors}/
		<rule><query/DOCDATE/   <save/{date}/
	      </rules> <!-- TITLEPAGE -->
	    </rule>
	  </rules> <!-- FRONT -->
	</rule>
      </rules> <!-- TEXT -->

    <rule><query/BODY/ <isa/Holder/
    <rule><query/BACK/ <isa/Holder/

    <rule><query/DIV1 DIV2 DIV3 DIV4 DIV5 DIV6 DIV7/ <isa/Section/
    <rule><query/HEAD/ <save/{title}/

    <rule><query/P/ <isa/Paragraph/
    <rule><query/EG/ <isa/Screen/

    <rule><query/LIST/ <isa>TEI_List ('type' => <attr/TYPE/)</isa>
    <rule><query/LABEL/ <isa/ListTerm/
    <rule><query/ITEM/ <isa/ListItem/

    <rule><query/PTR/  <isa>XRefEnd ('link' => <attr/TARGET/)</isa>

    <rule><query/TERM/ <isa/Inline_Quote/
    <rule><query/SOCALLED/ <isa/Inline_Quote/
    <rule><query/TITLE/  <isa/Inline_Quote/
    <rule><query/MENTIONED/ <isa/Inline_Quote/
    <rule><query/GI/     <isa/TEI_SGMLTag/
    <rule><query/IDENT/ <isa/Inline_Literal/
    <rule><query/CODE/ <isa/Inline_Literal/
    <rule><query/KW/ <isa/Inline_Literal/
    <rule><query/Q/ <isa>TEI_Quote ('rend' => <attr/REND/)</isa>
    <rule><query/EMPH/ <isa/Inline_Emphasis/
    <rule><query/HI/ <isa/Inline_Emphasis/
  </rules>
  <stuff>
sub save_attr {
    my ($self, $data, $event) = @_;
    my ($parent) = $data->{'diversion'}[-1];
    my ($id, $id_type, $id_attr);

    if ($id_attr = $event->data->attribute ('ID')) {
        $id_type = $id_attr->type;
        if ($id_type ne 'IMPLIED') {
            $id = $id_attr->value;
            $parent->{'id'} = $id;
            new Text::GDO::Reference ($data, 'object' => $parent, 'id' => $id);
        }
    }
}

package Text::GDO::TEI_SGMLTag;
@Text::GDO::TEI_SGMLTag::ISA = qw{Text::GDO::Inline};

sub as_string {
    my ($self, $context) = @_;

    return "<" . $self->{'source'}->as_string($context) . ">";
}

package Text::GDO::TEI_List;
@Text::GDO::TEI_List::ISA = qw{Text::GDO::DocObject};

sub new {
    my ($class, %args) = @_;
    my ($type) = "itemized";

  SWITCH:
    {
        ($args{'type'} =~ /^bullet/i)  && do {$type = "itemized"; last SWITCH};
        ($args{'type'} =~ /^ordered/i) && do {$type = "ordered";  last SWITCH};
        ($args{'type'} =~ /^gloss/i)   && do {$type = "variable"; last SWITCH};
        ($args{'type'} =~ /^simple/i)  && do {$type = "simple";   last SWITCH};
    }

    return new Text::GDO::List ('type' => $type);
}

package Text::GDO::TEI_Quote;
@Text::GDO::TEI_Quote::ISA = qw{Text::GDO::DocObject};

sub new {
    my ($class, %args) = @_;

    if ($args{'rend'} =~ /display/i) {
        return new Text::GDO::BlockQuote;
    } else {
        return new Text::GDO::Inline_Quote;
    }
}
</stuff>
</spec>
